
{$APPTYPE GUI}{$MODE DELPHI}

program demo84;

uses
  SysUtils,windows,math,gl,glu,glext,GraphOGL;

//const
 
//type
  
var 
  i:integer;
  TexReflection:GluInt;

   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1,1, 0,1, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure Scena;
begin
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 

  TextureSelectID(0);    
  SkyBox(0,0,0, 6);

  TextureSelectID(1);  
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10); 

  i:=i+1;
  
  glPushMatrix;
  glRotatef(i/5,0,1,0); 
  glTranslatef(10,10,0);    
  glRotatef(90,1,0,0); 
  Sfera(0,0,0, 2,20,20, 1);
  glPopMatrix;
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('sky_seaday6.bmp',0);
  TextureLoadID('Floor05.bmp',1); 
  TextureLoadID('wall.bmp',2);   
  
end;
begin 

  OpenGL_Texture();
  
  SetQualityTexture2(GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR);
  SetTexReflectionMap(128,TexReflection);
  
  xrot:=36;
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  GenTexReflectionMap(Scena,0,6,0,128,TexReflection);

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-1,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(0,1,0,0); 

  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1);   
  
  LightingOFF;  
  
  TextureSelectID(2); 	
  glPushMatrix;
  glTranslatef(2,6,0);    
  glRotatef(90,1,0,0);  
  Sfera(0,0,0, 5,32,32, 1/4);  
  glPopMatrix;  
  
  Cubo(-2,6,0, -3,-3,-3, 3,3,3, 1.5);  

  ReflectionMapBegin;
  BindTexReflectionMap(TexReflection);
  
  glPushMatrix;
  glTranslatef(2,6,0);    
  glRotatef(90,1,0,0); 
  CubeMapBegin(xrot,yrot);  
  Sfera(0,0,0, 5,32,32, 1);
  CubeMapEnd;  
  glPopMatrix; 
  
  glPushMatrix;
  glTranslatef(-2,6,0);
  CubeMapBegin(xrot,yrot);    
  Cubo(0,0,0, -3,-3,-3, 3,3,3, 1); 
  CubeMapEnd;    
  glPopMatrix;
  
  ReflectionMapEnd;  	  	
	
  LightingON;	
	
  Scena;
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Reflection map', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
